; Variable Manager v.97.2b
; Keith Batten kbatten@usa.net
; 18 October 1998
;
; Edited with Assembly Studio 86 v3.0
; Tab width set to 4

_AHL_PLUS_2_PG3		equ		4c3fh
_CXCURAPP			equ		0C1B4h

;*********************************************
;* 01 for the home screen                    *
;* 02 for the polynomial solver              *
;* 03 for the simultaneous equation solver   *
;* 05 for the constant editor                *
;* 06 for the vector editor                  *
;* 07 for the matrix editor                  *
;* 08 for the program editor                 *
;* 0c for the interpolate/extrapolate editor *
;* 0e for the list/stat editor               *
;* 12 for tolerance                          *
;* 19 for the table                          *
;* 1a for table setup                        *
;* 1b for link                               *
;* 1d for reset mem prompt                   *
;* 1e for reset defaults prompt              *
;* 1f for reset all prompt                   *
;* 20 for RAM                                *
;* 21 for mode/self test                     *
;* 23 for delete variables                   *
;* 49 for the function editor                *
;* 4a for the window editor                  *
;* 4c for the graph                          *
;* 53 initial conditions                     *
;* 54 axes something                         *
;* 62 for format                             *
;* 96 for cat/var                            *
;* 98 for an error message                   *
;*********************************************

;****************
;* 00 for real  *
;* 01 for cplx  *
;* 02 for vectr *
;* 03 for vectr *
;* 04 for list  *
;* 05 for list  *
;* 06 for matrx *
;* 07 for matrx *
;* 08 for cons  *
;* 09 for cons  *
;* 0A for equ   *
;* 0B for ????? *
;* 0C for strng *
;* 0D for gdb   *
;* 0E for gdb   *
;* 0F for gdb   *
;* 10 for gdb   *
;* 11 for pic   *
;* 12 for prgm  *
;****************

#include	"asm86.h"
#include	"ti86asm.inc"
#include	"ti86abs.inc"
#include	"ram86.inc"

;------BEGIN (SQRT)KEY LOADER------

NameLength	equ	19 + 11
#DEFINE		NAME	.db "Var Manager v.97.1b"

.org _asm_exec_ram

	nop
	jp		Start
	.dw		0000h
	.dw		Description
Description:
	.db		"(Un)install "
	NAME
	.db		0,0,0

Start:
	ld		hl,key_op_info		; load (sqrt)key op info into OP1
	rst		20h
	call	_FINDSYM			; is there already a (sqrt)key?
	jr		c, Install			; no so install ours

Uninstall:						; there already was a (sqrt)key
	call	_delvar				; so we uninstall it
	res		6,(iy+$24)			; reset the flag for (sqrt)key
	ld		hl, uninstalled
	call	_puts				; tell the user it was uninstalled
	call	_newline
	ret							; done for now

Install:
	ld		hl, installed		; tell the user we are installing it
	call	_puts
	call	_newline

	ld		hl, key_op_info		; load (sqrt)key op info into OP1
	rst		20h
	ld		hl, code_end - code_start	; get the length of the (sqrt)key program
	call	_CREATEPROG			; create the (sqrt)key program
	ld		a, b                ; convert bde to ahl
	ex		de, hl
	call	$4c3f               ; add 2 to ahl to point it to program data
	call	_SET_ABS_DEST_ADDR  ; set the destination to be our new (sqrt)key
	xor		a
	ld		hl,code_end - code_start  ; set number of bytes to copy
	call	_SET_MM_NUM_BYTES   ; as length of program
	xor		a
	ld		hl, code            ; point to the beginning of the program
	call	_SET_ABS_SRC_ADDR
	call	_mm_ldir            ; copy the program code
	set		6,(iy+$24)          ; set the flag for (sqrt)key

	ret

key_op_info:
	.db		$12,$4,$10
	.db		"KEY",0

installed:
	NAME
	.db		" Installed",0

uninstalled:
	NAME
	.db		" Uninstalled",0

;------END (SQRT)KEY LOADER------


;------BEGIN (SQRT)KEY PROGRAM------

code:
.org _asm_exec_ram-2			; set the start of code to the proper place
								; so calls and jps can be executed properly
code_start:
	.db		$8e,$28				; token for an asm program

	nop
	jp		Key_Start
	.dw		0000h
	.dw		Key_Description
Key_Description:
	NAME
	.db		" (DO NOT RUN!)",0
Key_Start:

	call	$479f				; pop OP1

	ld		a, ($d625)			; load a with the last key press
	bit		0, (iy+$20)
	jr		nz, skip_key
	push	af					; save the key press
	ld		a, (_CXCURAPP)		; load a with the current app state

check_delete:
	cp		$23					; make sure we are in the delete mode
	jr		nz, skip_and_pop	; if not make sure to POP a

	ld		hl, $C1EE			; this address holds the current variable
	rst		20h					; name selected, load it into OP1
	call	_FINDSYM			; see if it exists
	jr		c, skip_and_pop		; no so quit

;	I want to have it appear in any menu that has a valid variable, not just
;	the ALL menu

;	ld		a, ($FC00 + 6)		; ok this will check certain values
;	and		%00010000			; of pixels to make sure that we are
;	cp		%00010000			; on the DELETE|ALL screen
;	jp		z, skip_and_pop		; guess not so quit
;	ld		a, ($FC00 + 6)
;	and		%01000000
;	cp		%00000000
;	jp		z, skip_and_pop		; guess not so quit

	ld		hl, $3A36			; load hl with coordinates for the third
	ld		(_penCol), hl		; menu item (centered for certain text)
	ld		hl, rename_str		; place our text here
	call	_vputs				; this is a simple but effective patch
								; however i want to actually patch the
								; ROM's menu here to add other things

	pop		af					; time to intercept key presses

	cp		$2					; left
	jr		z, check_stats
	cp		$3					; right
	jr		z, check_stats

	cp		$33					; f-3
	jr		z, check_stats

skip_key:
	cp		a					; clear flags so the OS doesn't try
	ret							; to handle the key after we quit

skip_and_pop:
	pop		af					; make sure we have popped a if needed
	jr		skip_key

check_stats:
	ld		(key), a			; save the key pressed
	ld		hl, (_curRow)		; save the cursor row and column for
	push	hl					; the OS's use in refreshing the text

	ld		hl, $C1EE			; this address holds the current variable
	rst		20h					; name selected, load it into OP1
	call	_FINDSYM			; get the variable info

	ld		a, (hl)				; store the variable type into type
	ld		(type), a
	push	hl					; save the address of the variable symbol

	ld		a, (key)			; time to check key presses again
	cp		$2					; right
	jp		z, Change
	cp		$3					; left
	jp		z, Change
	cp		$33					; [F3]
	jr		z, rename
	jp		quit

rename:
	ld		hl, (_curRow)		; increment the cursor column
	inc		h					; so we are at the start of the
	ld		(_curRow), hl		; variable name

	ld		hl, blank			; clear the variable name from the screen
	call	_puts

	ld		hl, (_curRow)
	ld		h, 1				; reset the column to the start of
	ld		(_curRow), hl		; the variable name

	xor		a
	ld		(case), a			; reset the case flag we will be using
	ld		(size), a			; reset the variable length

	ld		a, $E1
 	call	_putmap
rename_loop:
    ld      a, (case)			; get the current case we are in
    add     a, $E1				; add to above to get correct cursor
    call    _putmap				; display it

	ld		a, (size)			; check to make sure the size doesn't
	cp		8					; get longer than 8 characters, if it
	jp		z, putname			; does then end input and save it

	call	set_case			; load the address of the correct keymap
								; into hl and the correct letter offset
								; into b

	push	hl					; save the address
	call	_getky				; get a key
	pop		hl					; restore address

	ld		e, a				; add the key value to the keymap address
	ld		d, 0				; to get the value of the key pressed
	add		hl, de
	ld		a, (hl)
	cp		0					; no key
	jr		z, rename_loop		; restart the loop
	cp		1					; enter
	jp		z, putname			; save the new name
	cp		2					; alpha
	jr		z, alpha			; swap between alpha modes
	cp		3					; second
	jr		z, second			; change to second mode
	cp		4					; exit
	jr		z, noname			; quit without renaming
	cp		5					; del
	jr		z, backspace		; go back one character if possible
	add		a, b				; no special key was pressed so display
	call	_putc				; the correct character

	ld		b, a				; save the character in b
	ld		hl, name			; load the offset of the name into hl
	ld		a, (size)			; load the size of name into a
	ld		e, a				; load de with a
	ld		d, 0				; add the offset of the name with the
	ld		a, b				; name length to get the offset to
	add 	hl, de				; put the character in
	ld		(hl), a				; load new character

	ld		a, (size)			; increment the size by one
	inc		a
	ld		(size), a

	ld		a, (case)			; display the correct cursor
	add		a, $E1
	call	_putmap
	jr		rename_loop			; restart the loop

set_case:						; get the offset for the correct keymap
								; and the value to add to the char
	ld		a, (case)			; check what mode we are in
	cp		2					; are we in second mode
	jr		z, set_case_second	; yes so get the second key map into hl
	ld		hl, alpha_keymap	; no so get the alpha key map into hl
	ld		b, 0				; reset the added value
	cp		0					; we are in ALPHA mode
	ret		z					; so return
	ld		b, 32				; we are in alpha mode so we need to add 32
	ret							; to the character to get the lower case char
set_case_second:
	ld		hl, second_keymap	; load hl with the second keymap offset
    ld		b, 0				; reset the added value
	ret

alpha:
	ld		hl, case			; load the current case into a
	ld		a, (hl)
	cp		0					; are we in upper case mode now?
	jr		z, alpha_lower		; yes, so set it to lower case mode
	ld		(hl), 0				; no, so set it to upper case mode
	jr		rename_loop			; restart the loop
alpha_lower:
	ld		(hl), 1				; set case to lower case
	jp		rename_loop			; restart the loop
	
second:
	ld		a, 2                ; set the case to second mode
	ld		(case), a
	jp		rename_loop         ; restart the loop

backspace:						; erase the last character if possible
	ld		a, (size)			; make sure the size is greater than zero
	cp		0
	jp		z, rename_loop		; nope, so dont backspace, restart the loop
	dec		a					; yup so decrease size by one
	ld		(size), a			; set the size
	ld		hl, (_curRow)		; write a ' ' over the last character
	ld		a, ' '
	call	_putmap
	dec		h					; decrement the column
	ld		(_curRow), hl
	jp		rename_loop			; restart the loop

noname:							; dont save the name
	pop     hl					; pop the address of the variable symbol
	pop     hl					; pop the row, col coords
	ld      a, $2E				; refresh the screen on quit
	cp		a
	ret

putname:						; now for the hard part, we have to play some
								; tricks with the vat to change the size of
								; the name, we will have to write the
								; function to handle increases, decreases and
								; static sizes. the way i went about this is
								; to first delete the name totally from the
								; vat (shrink the vat by the length of the
								; var name.  then i increase it by the length
								; of the new var name. that way it always
								; runs through the same functions

	ld		a, (size)			; get the size of the new variable name
	cp		0					; its zero so we want to quit without save
	jr		z, noname

	pop		hl					; pop the address of the variable's symbol
	ld		e, 5				; subtract 5 to it to get the start of the
	ld		d, 0				; variable name since the vat is backwards
	sbc		hl, de
	push	hl					; save the new address

	ld		a, (size)			; get the size of the new variable name
	ld		b, a				; save that in b
	ld      a, (hl)				; load the length of the old variable name
	cp		b					; compare the two lengths
	ld		(sizeaddr), hl		; save this address in sizeaddr
	pop		hl					; decrease the address to point to the start
	dec		hl					; of the variable, again because the vat is
	push	hl					; backwards, and then resave it
	ld		c, b				; save b into c
	jr		z, writename		; the lengths were the same so we dont have
								; to start moving things around, we can just
								; overwrite the old name

; hl holds address of beginning of name
; sizeaddr holds address of size
; a holds old name size
; c holds new name size

	cp		a					; clear flags
	ld		b, a				; save the old length into b
	ld		a, c
	ld		(newlength), a		; save the new length into newlength
	ld		a, b				; get the old length back to a

	ld		d, 0				; subtract a from the offset of the name
	ld		e, a				; to get the the "front" of the name
	sbc		hl, de				; its actually the end but is easier to use

	ld		d, h				; save hl into de
	ld		e, l
	sbc		hl, bc				; subtract the length from hl to get the
	ld		b, h				; number of times to repeat lddr
	ld		c, l
	ex		de, hl				; restore previous hl

	pop		de					; load de with the address to the start
	push	de					; of the variable name

	lddr						; move vat to overwrite old name

	ld		b, a				; save the old length in b
	ld		a, (newlength)		; save the new length in c
	ld		c, a

	ld		a, (size)			; load the length of the new size into a
	ld		hl, (VAT_END)		; get the address for the end of the vat
	ld		d, 0				; add the length of the old name to it
	ld		e, b				; since we have moved it to get the true
	add		hl, de				; end of the vat
	ld		b, 0				; now set hl to point to the end of the
	sbc		hl, bc				; vat after we insert our new name
	ld		(VAT_END), hl		; save that new address in 2 places (???)
	ld		(VAT_END + 3), hl	; not completely sure about this one

	ld		hl, (sizeaddr)		; put the new length into sizeaddr 
	ld		(hl), a

	pop		de					; load de with the place we want to insert
	push	de					; the new name into
	ld		hl, (VAT_END)		; get the end of the vat
	ex		de, hl				; swap hl and de for the subtraction
	sbc		hl, de				; subtract to find the number of bytes
	ld		b, h				; we want to move and put that in bc
	ld		c, l
	inc		bc					; increment bc so it points to the right spot

	ld		hl, (VAT_END)		; get the address for the end of the vat
	ld		d, 0				; in hl, then subtract the length of the new
	ld		e, a				; name to get the address for the new end
	sbc		hl, de				; of the vat
	ld		d, h				; save that into de
	ld		e, l				; get the current end of the vat into hl
	ld		hl, (VAT_END)
	ldir						; move the vat back to make room for the name

    ld      hl, (sizeaddr)		; get the address for the length byte
	dec		hl					; subtract one the get the start of the name
	ld		a, (size)			; get the new size
	ld		c, a				; save it in both b and c
	ld		b, a

;hl holds address of beginning of name
;b holds size
;c holds size
writename:						; now we actually copy the name
	ld		hl, name			; get the address for the new name into hl
	ld		d, 0
	ld		a, c				; get the offset for byte to read
	sub		b					; by subtracting the bytes left from the
								; total bytes

	ld		e, a				; add that offset to hl to get the address
	add		hl, de				; for the next byte to read
	ld		a, (hl)				; load that byte into a

	pop		hl					; get the address for the new name
	push	hl
	ld		(hl), a				; put the character in there
	dec		b					; decrement the number of chars left to copy
	ld		a, b				; see if we are done
	cp		0
	pop		hl					; decrement the address to write name to
	dec		hl					; and save it
	push	hl
	jr		nz, writename		; we're not done so keep copying

	pop		hl					; pop the address of the variable symbol
	pop		hl					; pop the row, col coords
	ld		a, $2E				; refresh the screen
	cp		a
	ret							; quit

Change:							; ok we're only changing the var type
    ld      a, (type)			; get the current type
	cp		$0C					; check if it is a string
	jr		z, Change_to_prgm	; ok so change to program
	cp		$12					; check if it is a program
	jr		z, Change_to_strng	; yup so change it to a string
	jr		quit				; it wasn't either so quit

Change_to_prgm:
	ld		a, $12				; load the program variable number into
	ld		hl, prgm			; a and the address for the program text
    ld      (type), hl			; into type
	jr		Change_next			; go on and change it and display correct text

Change_to_strng:
	ld		a, $0C				; load the string variable number into
	ld		hl, strng			; a and the address for the string text
    ld      (type), hl			; into type
	jr		Change_next			; go on and change it and display correct text

Change_next:
	ld		hl, (_curRow)		; get the correct screen coords to display
	ld		h, 16				; the new type at
	ld		(_curRow), hl
    ld      hl, (type)
	call	_puts				; display it

quit:
	pop		hl					; pop the address of var symbol
	ld		(hl), a				; save the var type change
	xor		a					; make sure the OS doesn't handle the key

	pop		hl					; pop the coords
	ld		(_curRow), hl		; restore the old coords
	ret							; quit

alpha_keymap:
	.db		$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db		$01,'X','T','O','J','E',$00,$00
	.db		$00,'W','S','N','I','D',$00,$00
	.db		'Z','V','R','M','H','C',$00,$05
	.db		'Y','U','Q','L','G','B',$00,$00
	.db		$00,$00,'P','K','F','A',$00,$02
	.db		$00,$00,$00,$00,$00,$03,$04,$00

second_keymap:
	.db		$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db		$01,$00,$00,$00,$00,$00,$00,$00
	.db		$00,'3','6','9',$00,$00,$00,$00
	.db		'.','2','5','8',$00,$00,$00,$05
	.db		'0','1','4','7',$00,$00,$00,$00
	.db		$00,$00,$00,$00,$00,$00,$00,$02
	.db		$00,$00,$00,$00,$00,$03,$04,$00

size:
	.db		0
case:
	.db		0

newlength:                      ; multiple labels to make the code a little
key:                            ; bit easier to read
	.db		0

type:                           ; multiple labels to make the code a little
sizeaddr:                       ; bit easier to read
	.db		0,0

blank:
	.db		"        ",0
name:
	.db		0,0,0,0,0,0,0,0,0

strng:
	.db		"STRNG",0
prgm
	.db		"PRGM ",0
rename_str:
	.db		"Name",0

code_end:


.end

